/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: core_support.S 7550 2013-06-07 03:06:07Z fsi-dankei $
 */

/*
 *		¸⥸塼 ֥ARMѡ
 */

#define TOPPERS_MACRO_ONLY
#define TOPPERS_ASM_MACRO
#define UINT_C(val)		(val)		/* ̵ޥ */
#define CAST(type, val)		(val)	/* 㥹ȤԤޥ */
#include "kernel_impl.h"
#include "offset.h"

/*
 * 㳰٥
 */
    .section .vector,"a"
    .global vector_table
vector_table:
    ldr pc, reset_vector       /* ꥻå             */
    ldr pc, undef_vector       /* ̤̿           */
    ldr pc, swi_vector         /* եȥ   */
    ldr pc, prefech_vector     /* ץեåܡ */
    ldr pc, data_abort_vector  /* ǡܡ       */
    ldr pc, reset_vector
    ldr pc, irq_vector         /* IRQ                  */
    ldr pc, fiq_vector         /* FIQ                  */


/*
 *  㳰٥̿ᤫ黲Ȥ
 *  襢ɥ쥹
 */
    .global vector_ref_tbl
vector_ref_tbl:
reset_vector:
    .long   start
undef_vector:
    .long   undef_handler
swi_vector:
    .long   swi_handler
prefech_vector:
    .long   prefetch_handler
data_abort_vector:
    .long   data_abort_handler
irq_vector:
    .long   irq_handler
fiq_vector:
    .long   fiq_handler

/*
 *  ǥѥå
 */
    .text
    .align 2
    .globl dispatch
dispatch:
    /*
     *  Υ롼ϡƥȡOS߶ػ߾֡ǥѥå
     *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
     *  
     */
    stmfd sp!, {r4 - r11,lr}           /* 쥸¸ */
    ldr   r0, =p_runtsk                /* p_runtskɤ߹ */
    ldr   r1, [r0]
    str   sp, [r1,#TCB_sp]             /* å¸ */
    adr   r2, dispatch_r
    str   r2, [r1,#TCB_pc]             /* ¹ԺƳϤ¸ */

    /*
     *  ¹楿ΥåΥХեå
     */
#ifdef CFG_USE_STACKMONITORING
    /*
     *  åݥ󥿥å
     */
    ldr   r3, [r1, #TCB_p_tinib]		/* ֥åƬɥ쥹 */
    ldr   r3, [r3, #TINIB_stk]			/* åƬɥ쥹 */
    cmp   sp, r3						/* åݥ <= åƬξ硤 */
    ble   stack_monitoring_error		/* åСեȯ */

    /*
     * ޥåʥСå
     */
    ldr   r4, [r3]						/* åƬɥ쥹ޥåʥСΰͼ */
    ldr   r3, =STACK_MAGIC_NUMBER
    cmp   r4, r3						/* ޥåʥС˲Ƥ硤 */
    bne   stack_monitoring_error		/* åСեȯ */
#endif /* CFG_USE_STACKMONITORING */

    b     dispatcher

dispatch_r:
    ldmfd sp!,{r4 - r11,lr}     /* 쥸 */
    bx    lr

/*
 *  ǥѥåưϡcpu_support.S
 */
    .globl start_dispatch
start_dispatch:
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 *  ǸƤӽФ롥ޤsp󥿥ƥѥåݥ
	 *  ξ֤ǸƤӽФ뤳ȤꤷƤ
	 *
	 *  dispatcherϡOS߶ػ߾֤ǸƤӽФ
     */    
    bl	  x_nested_lock_os_int
	bl    x_unlock_all_int
    mov   r0, #0
    ldr   r2, =excpt_nest_count            /* 㳰ʳ/CPU㳰ˤΥͥȲ0 */
    str   r0, [r2]
    b     dispatcher_0

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
    .globl exit_and_dispatch
exit_and_dispatch:
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  ¹楿ΥåΥХեå
	 */
	/*
	 *  åݥ󥿥å
	 */
    ldr   r0, =p_runtsk					/* p_runtskɤ߹ */
    ldr   r1, [r0]
    ldr   r2, [r1, #TCB_p_tinib]		/* ֥åƬɥ쥹 */
    ldr   r2, [r2, #TINIB_stk]			/* åƬɥ쥹 */
    cmp   sp, r2						/* åݥ <= åƬξ硤 */
    ble   stack_monitoring_error		/* åСեȯ */

	/*
	 *  ޥåʥСå
	 */
    ldr   r3, [r2]						/* åƬɥ쥹ޥåʥСΰͼ */
    ldr   r2, =STACK_MAGIC_NUMBER
    cmp   r3, r2						/* ޥåʥС˲Ƥ硤 */
    bne   stack_monitoring_error		/* åСեȯ */
#endif /* CFG_USE_STACKMONITORING */
    /* ǥѥåΡdispatcherˤ */

/*
 *  ǥѥå
 */
dispatcher:
    /*
     *  Υ롼ϡƥȡOS߶ػ߾֡ǥѥå
     *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
     *  롥¹ԺƳϤؤ⤳ξ֤Τޤʬ
     */
#ifdef LOG_DSP_ENTER
    ldr   r1, =p_runtsk     /* p_runtskѥ᡼ */
    ldr   r0, [r1]        
    cmp   r0, #0
    beq   1f
    bl    log_dsp_enter
1:
#endif /* LOG_DSP_ENTER */

    /*
     *  PostTaskHookθƤӽФ
     */
#ifdef CFG_USE_POSTTASKHOOK
    ldr   r0, =PostTaskHook
    cmp   r0, #0
    beq   dispatcher_0
posttaskhook_call:
    ldr   r0, =call_posttaskhook
	bl    stack_change_and_call_func_1
#endif /* CFG_USE_POSTTASKHOOK */

dispatcher_0:
    ldr   r0, =callevel_stat
	ldrh  r1, [r0]
	and   r1, r1, #(~TSYS_DISALLINT)
	strh  r1, [r0]
	bl    x_unlock_all_int

    ldr   r0, =p_schedtsk   /* p_schedtskp_runtsk */
    ldr   r1, [r0]
    ldr   r2, =p_runtsk   
    str   r1, [r2]        
    cmp   r1, #0            /* p_runtskNULLʤdispatcher_1 */
    beq   dispatcher_1             
    ldr   sp, [r1,#TCB_sp]  /* å */
#ifdef LOG_DSP_LEAVE
    mov   r0, r1            /* p_runtskѥ᡼ */
    mov   r4, r1            /* r1ϥå쥸ʤΤ¸ */
    bl    log_dsp_leave
    mov   r1, r4
#endif /* LOG_DSP_LEAVE */
    /*
     *  PreTaskHookθƤӽФ
     */
#ifdef CFG_USE_PRETASKHOOK
    ldr   r2, =PreTaskHook
    cmp   r2, #0
    beq   dispatcher_3
pretaskhook_call:
    mov   r4, r0            /* r0ϥå쥸ʤΤ¸ */
    mov   r5, r1            /* r1ϥå쥸ʤΤ¸ */
    ldr   r0, =call_pretaskhook
	bl    stack_change_and_call_func_1
    mov   r1, r5
    mov   r0, r4
#endif /* USE_PRETASKHOOK */
dispatcher_3:
    ldr   r4, [r1,#TCB_pc]  /* ¹ԺƳϤ */
    bx    r4
dispatcher_1:
    /*
     * OS߶ػ߾֤βȡ󥿥ƥȼ¹Ծ֤ؤ
     * 򤹤
     */
    ldr   r0, =_ostk            /* 󥿥ƥȤΥå */
    ldr   sp, [r0]    
    ldr   r1, =_ostksz
    ldr   r3, [r1]
    add   sp, sp, r3
	/* å쥸Ǥʤr4Ѥ */
    ldr   r4, =excpt_nest_count        /* r4 <-excpt_nest_count */
    /*
     *  callevel 
     */
    ldr	  r0, =callevel_stat
    mov	  r1, #TCL_ISR2
    strh  r1, [r0]
    mov   r0, #0
dispatcher_2:
    /*
     *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤġ
     *
     *  󥿥ƥȼ¹Ծ֤ڤ괹Τϡȯ
     *  ߽ˤɤΥåȤȤβȡ
     *  ϥɥǤΥǥѥåɻߤȤ2Ĥΰ̣
     *
     *  ץåԤ˰ܹԤȡߵĤȤϡԲ
     *  ʬ˹Ԥʤɬפ
     *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
     *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
     *  ˤ⤫餺ץåԤˤʤäƤޤ
     *
     *  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤ
     *  Τ褦ꤷʤȡߥϥɥ餫iget_tidƤӽ
     *  ݤưͤ˹פʤʤ
     *
     *  åȤˤäƤϡϥ⡼˰ܹԤ뤿ᡤɸˡ
     *  ۤʤ礬ɬפʾ礬
     *  Τ褦ʥåȤǤϡåȰ¸ˤơTOPPERS_CUSTOM_IDLE
     *  ֥ޥȤơtoppers_asm_custom_idle Ѱ
     *  Ф褤toppers_asm_custom_idle εҤˤäƤϡΥ쥸
     *  ϻѤǤʤ
     *     r0, r1, r2, r3, sp
     *
     */
    mov   r1, #1
    str   r1, [r4]                          /* excpt_nest_count = 1 */

#ifdef TOPPERS_CUSTOM_IDLE
    toppers_asm_custom_idle
#else
	bl    x_nested_unlock_os_int
    nop
	bl    x_nested_lock_os_int
#endif /* TOPPERS_CUSTOM_IDLE */

    ldr   r0, =p_runtsk       /* p_runtsk r1ɤ߹ */
    ldr   r1, [r0]
    ldr   r0, =p_schedtsk     /* p_schedtsk r2ɤ߹ */
    ldr   r2, [r0]
    cmp   r1, r2              /* p_runtskp_schedtskƱʤ */
    beq   dispatcher_2
    mov   r0, #0
    str   r0, [r4]        /* excpt_nest_count = 0 */

    /*
     *  callevel 
     */
    ldr   r5, =callevel_stat
    mov   r6, #TCL_TASK
    strh  r6, [r5]

    b     dispatcher_0

    /*
     *  åХեν
     */
#ifdef CFG_USE_STACKMONITORING
    /*
     *  åХեץƥեåƤӽФ
     *  å򹹤˲ʤᡤߥåνͤѤ
     */
    .global stack_monitoring_error_isr
stack_monitoring_error_isr:
    bl    x_nested_lock_os_int			/* ISR褿OS߶ػߤˤʤäƤʤ */

    .global stack_monitoring_error
stack_monitoring_error:
    ldr   r2, =excpt_nest_count			/* _ostkptȤexcpt_nest_count򥤥󥯥Ȥ */
    ldr   r3, [r2]
    add   r3, r3, #1
    str   r3, [r2]
    ldr   r2, =_ostkpt					/* å򹹤˲ʤᡤߥåνͤѤ */
    ldr   sp, [r2]

    mov   r0, #E_OS_STACKFAULT		 	/* ץƥեåΰ */
    b     call_protectionhk_main		/* ץƥեåƤӽФ */
    /*
     *  ץƥեåäƤʤ
     */
#endif /* CFG_USE_STACKMONITORING */

/*
 *  ϻ
 *
 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
 *  λݸԤ
 */
    .text
    .globl start_r
start_r:
    mov   r5, r1            /* r1ϥå쥸ʤΤ¸ */
	bl    x_nested_unlock_os_int
    ldr   lr, = exit_task                    /*  */
    ldr   r2, [r5, #TCB_p_tinib]            /* p_runtsk->p_tinibr2  */
    ldrb  r4, [r2, #TINIB_exepri]           /* ¹Գϻͥټ  */
    strb  r4, [r5, #TCB_curpri]             /* ߤͥ٤  */
    ldr   r1, [r2, #TINIB_task]             /* ưϤ˥ */
    bx    r1

/*
 *  ߥϥɥ/CPU㳰ϥɥи
 *
 *  ret_intϡߥϥɥ餫äľ˼¹Ԥ롼ǡ
 *  ߥϥɥ齪λ塤åȰ¸ν¹Ԥ塤
 *  OSߤػߡåΥåˤ
 *  ֤ǸƤӽФ
 *  r3ˤcallevel_statäƤ
 */
    .text
    .global ret_int
ret_int:
    /*
     *  㳰ߤΥͥȥȡexcpt_nest_count)Υǥ
     */
    ldr   r0, =excpt_nest_count   /* r0 <-excpt_nest_count */
    ldr   r1, [r0]
    sub   r2, r1, #1
    str   r2, [r0]
    cmp   r2, #0                  /* 褬󥿥ƥȤʤ */
    bne   ret_int_1               /* ˥꥿                   */

	/*
	 * C1ISR, CPU㳰θ˥ǥѥåϤʤ
	 */
	and   r3, r3, #TCL_ISR2
	cmp   r3, #TCL_ISR2
	bne   ret_int_1

    /*
     *  reqflgå˳ߤػߤΤϡreqflgå
     *  ľ˳ߥϥɥ餬ư졤ǥǥѥå׵
     *  줿ˡ˥ǥѥåʤȤ꤬뤿
     *  Ǥ
     */

    ldr   r0, =p_runtsk       /* p_runtsk r1ɤ߹ */
    ldr   r1, [r0]
    ldr   r0, =p_schedtsk     /* p_schedtsk r2ɤ߹ */
    ldr   r2, [r0]
    cmp   r1, r2              /* p_runtskp_schedtskۤʤʤret_int_2 */
    bne   ret_int_2
ret_int_1:
    /*
     *  ߽Υ꥿ˤꡤ߶ػ߲֤˰ܹԤʤ
     *  ʤʤ
     *  ARMǤϡCPSRIRQӥåȤ߶ػ߲֤Ȥ뤿ᡤñ˥꥿
     *  Ф褤
     */
    ldmfd sp!,{r1}              /* CPSR */
    msr   spsr, r1              /* cpsrspsr */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /* ƥȤ^դʤΤǡcpsr <- spsr */

ret_int_2:
ret_int_3:
    /*
     *  ؤϡCPU㳰ϥɥνиʬƤ
     *
     *  Ǥϡ褬Ǥꡤåϡåξ
     *  ˥å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
     *  ץåϡѡХ⡼ɡOSߤػ
     *  ֤ȤʤäƤ
     */

    /*
     *  OS߶ػ߾֤˰ܹԤ
     *
     *  λOS߶ػ߾֤ȤΤϡdispatcherʬˡ
	 *  OS߶ػ߾֤ˤʤäƤɬפ뤿Ǥ
     */
	bl    x_nested_lock_os_int
	bl    x_unlock_all_int

    /*
     *  p_runtskp_schedtskƱˤϡǥѥåԤʤ
     */

    ldr   r0, =p_runtsk       /* p_runtsk r1ɤ߹ */
    ldr   r1, [r0]
    ldr   r0, =p_schedtsk     /* p_schedtsk r2ɤ߹ */
    ldr   r2, [r0]
    cmp   r1, r2              /* p_runtskp_schedtskƱʤ */
    beq   ret_int_4           /*                    ret_int_4 */
    stmfd sp!, {r4-r11}       /* ĤΥ쥸¸ */
    str   sp, [r1,#TCB_sp]    /* å¸ */
    adr   r0, ret_int_r       /* ¹ԺƳϤ¸   */
    str   r0, [r1,#TCB_pc]
    b     dispatcher

ret_int_r: 
    ldmfd sp!, {r4-r11}       /* 쥸 */
ret_int_4:
    ldmfd sp!, {r0}             /* spsr  */
	mrs   r1,cpsr
	and   r1,r1,#(CPSR_IRQ_BIT)
	orr   r0,r0,r1
    msr   spsr,r0               /* cpsrspsr */
    bl    x_nested_unlock_os_int
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /*  ^դʤΤǡcpsr <- spsr */

/*
 * CPU㳰ϥɥ
 *
 * CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ
 * 
 */

/*
 *  ̤̿ 㳰ϥɥ
 */
    .text
    .align 2
    .global undef_handler
undef_handler:
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_INTLOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿̤⡼ɤ
     */
    msr   cpsr, #(CPSR_UND|CPSR_INTLOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr
    mov   r2, #EXCH_NO_UNDEF
    b     target_exc_handler


/*
 *  SWI 㳰ϥɥ
 */
    .text
    .align 2
    .global swi_handler
swi_handler:
    /* 
     *  ư⡼(ѡХ⡼)
     *  ѡХ⡼ɤ߶ػ߾֤Ȥ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_INTLOCK|CPSR_ALWAYS_SET)
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */
    mov   r0, lr
    mrs   r1, spsr
    mov   r2, #EXCH_NO_SWI
    b     target_exc_handler

/*
 *  ץեåܡ 㳰ϥɥ
 */
    .text
    .align 2
    .global prefetch_handler
prefetch_handler:
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_INTLOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿˥ܡȥ⡼ɤ
     */
    msr   cpsr, #(CPSR_ABT|CPSR_INTLOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr
    mov   r2, #EXCH_NO_PABORT
    b     target_exc_handler


/*
 *  ǡܡ 㳰ϥɥ
 */
    .text
    .align 2
    .global data_abort_handler
data_abort_handler:
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_INTLOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿˥ܡȥ⡼ɤ
     */
    msr   cpsr, #(CPSR_ABT|CPSR_INTLOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_DABORT
    b     target_exc_handler

#ifndef TARGET_FIQ_HANDLER
/*
 *  FIQ 㳰ϥɥ
 */
    .text
    .align 2
    .global fiq_handler
fiq_handler:
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_INTLOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿FIQ⡼ɤ
     */
    msr   cpsr, #(CPSR_FIQ|CPSR_FIQ_BIT|CPSR_INTLOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_FIQ
    b     target_exc_handler
#endif /* TARGET_FIQ_HANDLER */

#ifdef __thumb__
    .text
    .align 2
    .global current_sr
current_sr:
    mrs   r0, cpsr
    bx    lr

   .global set_sr
set_sr:
    msr   cpsr, r0
    bx    lr
#endif /* __thumb__ */

    .text
    .align 2
    .global stack_change_and_call_func_1
    .global stack_change_and_call_func_2
stack_change_and_call_func_1:
stack_change_and_call_func_2:
    /*
     * ȯΥƥȤȽ
     */
	push  {r4, lr}
    ldr   r3, =excpt_nest_count
    ldr   r4, [r3]
    add   r4, r4, #1
    str   r4, [r3]
    cmp   r4, #1
    bne   1f

	mov   r3, sp
    ldr   r4, =_ostkpt
	ldr   sp, [r4]
	push  {r3}
1:
    
	mov   r3, r0
	mov   r0, r1
	mov   r1, r2
	mov   lr, pc
	bx    r3

    ldr   r3, =excpt_nest_count
    ldr   r4, [r3]
    sub   r4, r4, #1
    str   r4, [r3]
    cmp   r4, #0
    bne   1f

	pop   {r3}
	mov   sp, r3

1:

	pop   {r4, lr}
	bx    lr
