#
# variable definition
#
INCLUDES = []
CFG1_DEF_TABLES = []

#
# set cfg and cfg kernel param
#
CFG = SRCDIR + "cfg/cfg/cfg.exe"
CFG_KERNEL = "atk2_no_osap"

#
# files for each project 
#
app_files = []
app_configuration_files = ['Os_Lcfg_asm.asm','Os_Lcfg.c']
app_sysmod_files = ['sysmod/banner.c', 'sysmod/serial.c', 'sysmod/syslog.c']
app_library_files = ['library/histogram.c', 'library/log_output.c', 'library/strerror.c', 'library/t_perror.c', 'library/vasyslog.c']

kernel_kernel_files = ['kernel/alarm.c','kernel/counter.c','kernel/counter_manage.c','kernel/event.c','kernel/interrupt.c','kernel/interrupt_manage.c','kernel/osctl.c','kernel/osctl_manage.c','kernel/resource.c','kernel/scheduletable.c','kernel/task.c','kernel/task_manage.c']

cfg_files = []
cfg_configuration_files = ['cfg1_out.c']

#
# pre/postbuiled file
#
cfg_pre_python_files = ['arch/cx/pre_cfg.py']
cfg_post_python_files = ['arch/cx/post_cfg.py']
atk2_sc1_post_python_files = ['arch/cx/post_atk2.py']

#
# cubesuite+ depend files
#
atk2_sc1_rel_includes = [".","cfg"]
cfg_rel_includes = [".."]
kernel_rel_includes = ["..\cfg"]

#
# library
#
atk2_sc1_lib_includes = [r'kernel\%BuildModeName%']
atk2_sc1_lib_files = ['kernel']

#
# cx define
#
kernel_define = ['ALLFUNC', 'TOPPERS_LABEL_ASM']


#
# cx additional option
#  -Xno_warning=20177 : Suppress warnings no refer label(exit_no_errorhooh, d_exit_no_errorhook) 
kernel_addopt = ['-Xno_warning=20177','-Xno_warning=50013']

#
# Set cfg path and srdir path
#
cfg = proj_rel_dir + CFG
srcdir = proj_rel_dir + SRCDIR

#
# soucre target file
#
execfile(srcdir + "target/" + TARGET + "/target.py")

#
# merge files
#
app_files.append(statup_file)
app_files = app_files + app_sysmod_files + app_library_files
cfg_files = cfg_files + cfg_files
kernel_files = kernel_kernel_files + kernel_target_files + kernel_arch_files

#
# Set include path and cfg1_def_table
#
INCLUDES = USER_INCLUDE + ["", "arch", "include", "kernel", "arch", "sysmod", "library"] + INCLUDES
CFG1_DEF_TABLES = ["kernel/kernel_def.csv"] + CFG1_DEF_TABLES

API_TABLE = "/kernel/kernel_api.csv"
CFG_TF = "target/" + TARGET + "/target.tf"
CFG_OFFSET_TF = "target/" + TARGET + "/target_offset.tf"
CFG_CHECK_TF = "target/" + TARGET + "/target_check.tf"

#
# make cfg include path
#
cfg_includes = ""
for include in INCLUDES:
	cfg_includes = cfg_includes + " -I" + srcdir + include

#
# make cfg1_def_table
#
cfg_cfg1_def_tables = ""
for cfg1_def_table in CFG1_DEF_TABLES:
	cfg_cfg1_def_tables = cfg_cfg1_def_tables + " --cfg1-def-table " + srcdir + cfg1_def_table

#
# Set api_table
#
cfg_api_table = srcdir + API_TABLE

#
# Set tf 
#
cfg_tf =  srcdir + CFG_TF

#
# Set offset tf 
#
cfg_offset_tf =  srcdir + CFG_OFFSET_TF

#
# Set check tf 
#
cfg_check_tf =  srcdir + CFG_CHECK_TF

#
#
# Functions
#
#
import re

#
# Set Cx Includes
# 
def SetCxIncludes(inputstr, include_list, rel_include_list, relpath):
	cx_includes = ""
	for include in rel_include_list:
		include_list.append(relpath + include)
	for include in include_list:
		cx_includes = cx_includes + include + "\n"
	cx_includes = cx_includes.replace('/', r'\\')
	pattern_pre = r'(\s\<AdditionalIncludePaths-0\>)[\s\S]+?(\</AdditionalIncludePaths-0\>)'
	pattern_post = r'\1' + cx_includes + r'\2'
	inputstr = re.sub (pattern_pre, pattern_post, inputstr)
	return inputstr

#
# ChangeSetItemXml
#
def ChangeItemXml(inputstr, xml_pattern, newitemstr):
	pattern_pre = r'<' + xml_pattern + r'>[\s\S]+?</' + xml_pattern + '>'
	pattern_post = '<' + xml_pattern + '>' + newitemstr + '</' + xml_pattern + '>'
	inputstr = re.sub (pattern_pre, pattern_post, inputstr)
	return inputstr

#
# NewSetItemXml
#
def NewSetItemXml(inputstr, xml_pattern, newitemstr):
	pattern_pre = r'\<' + xml_pattern + r' /\>'
	pattern_post = r'<' + xml_pattern + r'>' + newitemstr + '</' + xml_pattern + r'>'
	inputstr = re.sub (pattern_pre, pattern_post, inputstr)
	return inputstr

#
# NewSetItemXmlOnce
#
def NewSetItemXmlOnce(inputstr, xml_pattern, newitemstr):
	pattern_pre = r'\<' + xml_pattern + r' /\>'
	pattern_post = r'<' + xml_pattern + r'>' + newitemstr + '</' + xml_pattern + r'>'
	inputstr = re.sub (pattern_pre, pattern_post, inputstr, 1)
	return inputstr

#
# New set Cx Include
#
def NewSetCxIncludes(inputstr, include_list, rel_include_list, relpath):
	cx_includes = ""
	for include in rel_include_list:
		include_list.append(relpath + include)
	for include in include_list:
		cx_includes = cx_includes + include + "\n"
	cx_includes = cx_includes.replace('/', r'\\')
	return NewSetItemXml(inputstr, 'AdditionalIncludePaths-0', cx_includes)

#
# New set library Include
#
def NewSetLibIncludes(inputstr, include_list, rel_include_list, relpath):
	lib_includes = ""
	for include in rel_include_list:
		include_list.append(relpath + include)
	for include in include_list:
		lib_includes = lib_includes + include + "\n"
	lib_includes = lib_includes.replace('/', r'\\')
	return NewSetItemXml(inputstr, 'AdditionalLibraryPaths-0', lib_includes)

#
# New set library files
#
def NewSetLibFiles(inputstr, file_list):
	lib_files = ""
	for file in file_list:
		lib_files = lib_files + file + "\n"
	lib_files = lib_files.replace('/', r'\\')
	return NewSetItemXml(inputstr, 'LibraryFiles-0', lib_files)

#
# New set prebuild
#
def NewSetPrebuild(inputstr, rel_command_list, relpath):
	command_str = ''
	for command in rel_command_list:
		command_str = command_str + relpath + command
	command_str = r'#!python\ncommon.Source("' + command_str + r'")\n'
	return NewSetItemXml(inputstr, 'PreBuildCommands-0', command_str)


#
# New set postbuild
#
def NewSetPostbuild(inputstr, rel_command_list, relpath):
	command_str = ''
	for command in rel_command_list:
		command_str = command_str + relpath + command
	command_str = r'#!python\ncommon.Source("' + command_str + r'")\n'
	return NewSetItemXml(inputstr, 'PostBuildCommands-0', command_str)


#
# New set Define
#
def NewSetDefine(inputstr, define_list):
	define_str = ''
	for define in define_list:
		define_str = define_str + define + '\n'
	return NewSetItemXml(inputstr, 'MacroDefinitions-0', define_str)

#
# New set additional options
#
def NewSetAddOpt(inputstr, option_list):
	option_str = ''
	for option in option_list:
		option_str = option_str + option + ' '
	return NewSetItemXmlOnce(inputstr, 'OtherAdditionalOptions-0', option_str)


#
# Set target file relative path
#
def SetTargetFileRelativePath(inputstr, file_list, relpath):
	relpath_win = re.sub(r'/',r'\\\\', relpath)
	for file_path in file_list:
		file_path = re.sub(r'/',r'\\\\',file_path)
		pattern_pre = r'(\s\<RelativePath\>).+?' + file_path + r'(\</RelativePath\>)'
		pattern_post = r'\1' + relpath_win + file_path + r'\2'
		inputstr = re.sub (pattern_pre, pattern_post, inputstr)
	return inputstr


#
# Set python file relative path
#
def SetPythonFileRelativePath(inputstr, file_list, relpath):
	for file_path in file_list:
		pattern_pre = r'".+?' + file_path + r'"'
		pattern_post = r'"' + relpath + file_path + r'"'
		inputstr = re.sub (pattern_pre, pattern_post, inputstr)
	return inputstr

def ReadFile(filename):
	f = open(filename, "r")
	str = f.read()
	f.close()
	return str

def WriteFile(filename, str):
	f = open(filename, "w")
	f.write(str)
	f.close()



