﻿#!python
# -*- coding: utf-8 -*-
import os.path
import os
import shutil

# call common file
common.Source(src_abs_path + "/arch/cx/common.py")

src_abs_path = os.path.abspath(SRCDIR)
wd_abs_path = os.path.abspath('.')
cfg_mtsp = wd_abs_path + r"\cfg\cfg.mtsp"
kernel_mtsp = wd_abs_path + r"\kernel\kernel.mtsp"
atk2_sc1_mtpj = wd_abs_path + r"\atk2-sc1.mtpj"


if COPY_SAMPLE1:
	shutil.copy(src_abs_path + r'/sample/sample1.c', '.')
	shutil.copy(src_abs_path + r'/sample/sample1.h', '.')
	shutil.copy(src_abs_path + r'/sample/sample1.cfg', '.')

#
# close project
#
#project.Close() 
print wd_abs_path + "\\atk2-sc1"
project.Create(wd_abs_path + "\\atk2-sc1",
				MicomType.V850, 
				TARGET_MCU, 
				ProjectKind.Application,
				Compiler.CX,
				False)

project.Create(wd_abs_path + "\\cfg\\cfg",
				MicomType.V850, 
				TARGET_MCU, 
				ProjectKind.Application,
				Compiler.CX,
				True)

project.Create(wd_abs_path + "\\kernel\\kernel",
				MicomType.V850, 
				TARGET_MCU, 
				ProjectKind.Library,
				Compiler.CX,
				True)

#
# Change debug tool
#
debugger.DebugTool.Change(DebugTool.E1Jtag)

#
# Add files for atk2-sc1
#
for file in app_app_files:
	project.File.Add(wd_abs_path + "\\" + file, u"app")

for file in app_sysmod_files:
	project.File.Add(src_abs_path + "\\" + file, u"sysmod")

for file in app_library_files:
	project.File.Add(src_abs_path + "\\" + file, u"library")

for file in app_configuration_files:
	project.File.Add(wd_abs_path + "\\cfg\\" + file, u"configuration")

str = src_abs_path + '\\' + statup_file
project.File.Add(str, u"スタートアップ")

#
# Add files fot cfg
#
project.Change(cfg_mtsp)

file_list = project.File.Information()
for file in file_list:
	project.File.Remove(file)

str = src_abs_path + '\\' + statup_file
project.File.Add(str, u"スタートアップ")

for file in cfg_configuration_files:
	project.File.Add(wd_abs_path + "\\cfg\\" + file, u"configuration")

#
# Add files fot kernel
#
project.Change(kernel_mtsp)

file_list = project.File.Information()
for file in file_list:
	project.File.Remove(file)

for file in kernel_kernel_files:
	project.File.Add(src_abs_path + "\\" + file, u"kernel")

for file in kernel_arch_files:
	project.File.Add(src_abs_path + "\\" + file, u"arch")

for file in kernel_target_files:
	project.File.Add(src_abs_path + "\\" + file, u"target")


project.Close(True)


#
# Modify atk2-sc1.mtpfj
#
inputstr = ReadFile('atk2-sc1.mtpj')

# Set cx include path
inputstr = NewSetCxIncludes(inputstr, atk2_sc1_rel_includes, INCLUDES, SRCDIR)
# Set libary path and file
inputstr = NewSetLibIncludes(inputstr, atk2_sc1_lib_includes, [], SRCDIR)
inputstr = NewSetLibFiles(inputstr, atk2_sc1_lib_files)
# change Option
inputstr = ChangeItemXml(inputstr, 'OutputMessageFormat-0', '%Program% %Options%')
inputstr = ChangeItemXml(inputstr, 'UseProEpiRuntimeLibrary-0', 'False')
inputstr = ChangeItemXml(inputstr, 'HexadecimalFileFormat-0','MotrolaSType32Bit')
inputstr = ChangeItemXml(inputstr, 'HexadecimalFileName-0', r'%ProjectName%.srec')
inputstr = ChangeItemXml(inputstr, 'OutputLinkMapFile-0', 'True')
inputstr = ChangeItemXml(inputstr, 'OutputSymbolInformationToLinkMapFile-0', 'True')
inputstr = ChangeItemXml(inputstr, 'DebuggerProperty-EssentialProperty-Clock-MainClockGeneration', MAIN_CLK)

                                    
# Set Prebuild/Postbuile
inputstr = NewSetPostbuild(inputstr, atk2_sc1_post_python_files, SRCDIR)

WriteFile('atk2-sc1.mtpj', inputstr)

#
# Modify ./cfg/cfg.mtsp
#
inputstr = ReadFile('./cfg/cfg.mtsp')

# Set cx include path
inputstr = NewSetCxIncludes(inputstr, cfg_rel_includes, INCLUDES, SRCDIR + "../")

# change Option
inputstr = ChangeItemXml(inputstr, 'OutputMessageFormat-0', '%Program% %Options%')
inputstr = ChangeItemXml(inputstr, 'UseProEpiRuntimeLibrary-0', 'False')
inputstr = ChangeItemXml(inputstr, 'HexadecimalFileFormat-0','MotrolaSType32Bit')
inputstr = ChangeItemXml(inputstr, 'HexadecimalFileName-0', 'cfg1_out.srec')
inputstr = ChangeItemXml(inputstr, 'OutputLinkMapFile-0', 'True')
inputstr = ChangeItemXml(inputstr, 'OutputSymbolInformationToLinkMapFile-0', 'True')
inputstr = ChangeItemXml(inputstr, 'HexadecimalFileOutputFolder-0', '.')

# Set Prebuild/Postbuile
inputstr = NewSetPrebuild(inputstr, cfg_pre_python_files, SRCDIR + "../")
inputstr = NewSetPostbuild(inputstr, cfg_post_python_files, SRCDIR + "../")

WriteFile('./cfg/cfg.mtsp', inputstr)

#
# Mofity ./kernel/kernel.mtsp
#
inputstr = ReadFile('./kernel/kernel.mtsp')

# Set cx include path
inputstr = NewSetCxIncludes(inputstr, kernel_rel_includes, INCLUDES, SRCDIR + "../")
# Set cx define
inputstr = NewSetDefine(inputstr, kernel_define)
# Set cx addition option
inputstr = NewSetAddOpt(inputstr, kernel_addopt)

# change Option
inputstr = ChangeItemXml(inputstr, 'UseProEpiRuntimeLibrary-0', 'False')

WriteFile('./kernel/kernel.mtsp', inputstr)

project.Open(wd_abs_path + r'\atk2-sc1.mtpj')
project.Change(atk2_sc1_mtpj)
