/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: ostm.c 7959 2013-10-10 05:06:00Z fsi-dankei $
 */

#include "kernel_impl.h"
#include "target_timer.h"
#include "ostm.h"
#include "Os_Lcfg.h"

/*
 *  ߤΥƥñ: ߥá
 *
 *  ̩ˤϡΥƥåΥƥ
 */
SystemTimeMsType current_time;

/*
 *	ؿץȥ
 */
ISR(target_timer_hdr);

/*
 *  ޥñ̤Ǥλ
 */
SystemTimeUsType
get_tim_utime(void)
{
	SystemTimeUsType	utime;
	SystemTimeMsType	mtime;
	TickType			clock1, clock2;
	boolean				ireq;
	SIL_PRE_LOC;

	SIL_LOC_INT();
	mtime = current_time;
	clock1 = target_timer_get_current();
	ireq = target_timer_probe_int();
	clock2 = target_timer_get_current();
	SIL_UNL_INT();
	utime = ((SystemTimeUsType) mtime) * 1000U;

	if ((ireq != FALSE) && (clock2 >= clock1)) {
		/*
		 *  ߤäƤꡤclock2clock1礭ޤϡ
		 *  current_time ߤˤ깹Ƥʤġclock1ϥХե
		 *  ͤǤ뤿ᡤutime1mɲä롥clock1ɤ߹ߡߤΥå
		 *  clock2ɤ߹ߤ1sʲǼ¹Բǽʥץå¸ߤ뤿ᡤդ
		 *  ӤƤ롥
		 */
		utime += 1000U;
	}
	utime += TO_USEC(clock1);

	return(utime);
}

/*
 *  OSTMν
 */
void
target_timer_initialize(void)
{
	/*  */
	sil_wrb_mem((void *) (OSTM_TT_B), 0x01);

	/* 󥿡Х롦ޡ⡼ */
	sil_wrb_mem((void *) (OSTM_CTL_B), 0x00);

	/* ڥ쥸 */
	sil_wrw_mem((void *) (OSTM_CMP_W), TIMER_CLOCK);

	/*  */
	sil_wrb_mem((void *) (OSTM_TS_B), 0x01);
}

/*
 *  OSTM
 */
void
target_timer_terminate(void)
{
	/*  */
	sil_wrb_mem((void *) (OSTM_TT_B), 0x01);

	/* ߤζػߤȥꥢ */
	x_disable_int(OSTM_IRQ);
	x_clear_int(OSTM_IRQ);
}

/*
 *  target_timer.cfgINCLUDEʤн
 */
#ifndef SysTimerCnt
#define SysTimerCnt		UINT_C(0)
#endif /* SysTimerCnt */

/*
 *  ޳ߥϥɥ
 */
ISR(target_timer_hdr)
{
	StatusType ercd;

	/* current_time򹹿 */
	current_time++;

	/*
	 *  󥿲ûν¹
	 */
	ercd = IncrementCounter(SysTimerCnt);
	/* 顼꥿ξϥåȥ */
	if (ercd != E_OK) {
		ShutdownOS(ercd);
	}
}
