/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: start.S 7254 2013-03-28 00:30:26Z fsi-dankei $
 */

/*
 *		ͥбΥȥåץ⥸塼V850ѡ
 */

#define OMIT_INCLUDE_OS_CFG		/* Os_Cfg.h󥯥롼޻ */
#define TOPPERS_MACRO_ONLY
#define UINT_C(val)			(val)		/* ̵ޥ */

#include <v850asm.inc>
#include "kernel_impl.h"

	.section .text
	.align  4
	.global _reset

_reset:
	di                                  /* ߶ػ */

	/*
	 * Ƽݥ󥿤ν(SP/TP/EP/GP/CTBP)
	 */
	Lea     __ostkpt, r3
	ld.w    0[r3], r3
	Lea     __tp, tp
	Lea     __ep, ep
	Lea     __gp, gp
	Lea     __ctbp, r6
	ldsr    r6, 20
	
	/*
	 *  hardware_init_hook θƽФ0 Ǥʤ
	 *
	 *  åȥϡɥ˰¸ɬפʽ
	 *  ϡhardware_init_hook ȤؿѰդ롥
	 */

	Lea     hardware_init_hook, r1
	cmp     r0, r1
	be      hardware_init_hook_end
	jarl    hardware_init_hook, lp
hardware_init_hook_end:
	/*
	 *  bssΥꥢ
	 *   饤󤵤ƤΤ4ĹԤ
	 */
	Lea     __bss_start, ep
	Lea     __bss_end, r6
bss_clear_start:
	cmp     ep, r6
	be      bss_clear_end
	sst.w   r0, 0[ep]
	add     4, ep
	br      bss_clear_start
bss_clear_end:
#ifndef OMIT_DATA_INIT
	/*
	 *  dataνROMб
	 *
	 *  __idata_start  __idata_end ޤǤ__data_start ʹߤ
	 *  ԡ롥
	 */
	Lea     __idata_start, r6
	Lea     __idata_end,   r7
	Lea     __data_start,  r8
data_init_start:
	cmp     r6, r7
	be      data_init_end
	ld.w    0[r6], r9
	st.w    r9, 0[r8]
	add     4, r6
	add     4, r8
	br      data_init_start
data_init_end:
#endif /* OMIT_DATA_INIT */
	/*
	 *  software_init_hook ƽФ0 Ǥʤ
	 *
	 *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
	 *  ϡsoftware_init_hook ȤؿѰդ
	 *  褤
	 */
	Lea     software_init_hook, r1
	cmp     r0, r1
	be      software_init_hook_end
	jarl    software_init_hook, lp
software_init_hook_end:


 	jarl    _target_hardware_initialize, r31
	jarl    _main, r31
	halt
	.end
