/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_config.c 7933 2013-10-02 10:59:02Z shigihara $
 */

/*
 *		åװ¸⥸塼AT91SKYEYEѡ
 */

#include <stdlib.h>
#include "kernel_impl.h"
#include "target_serial.h"
#ifdef ENABLE_RETURN_MAIN
#include "interrupt.h"
#endif /* ENABLE_RETURN_MAIN */
#ifdef TOPPERS_ENABLE_TRACE
#include "target_sysmod.h"
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */


/*
 * Ƴߤγ׵ػߥե饰ξ
 */
uint32			idf;

/*
 * ߤγͥ٥ޥ
 */
PriorityType	ipm;

/*
 *  ʸνϡʥСåѡ
 */
void
target_fput_str(char8 *c)
{
	while (*c != '\0') {
		usart0_putc(*c++);
	}
	usart0_putc('\n');
}

/*
 *  Сå
 */
static void
version_check(void)
{
	/* SkyEyeΥСǧ */
	if (sil_rew_mem((uint32 *) (SKYEYE_VER_REG)) != SUPPORT_SKYEYE_VER) {
		target_fput_str("SkyEye version is mismatch!!");
		while (1) {
		}
	}

	if ((sil_rew_mem((uint32 *) (DEVM_VER_REG)) & 0xfff0)
		!= (SUPPORT_DEVM_VER & 0xfff0)) {
		target_fput_str("DeviceManager Extension version is mismatch!!");
		while (1) {
		}
	}
}

void
target_hardware_initialize(void)
{
	/*
	 *  target_fput_logȤ褦USART0
	 */
	usart0_initialize();

	/*
	 *  Сγǧ
	 */
	version_check();
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{

	/*
	 *  ARM¸ν
	 */
	core_initialize();

	/*
	 * Ƴߤγ׵ػߥե饰ػ
	 */
	idf = ~0U;

	/*
	 * ͥ٥ޥ0
	 */
	ipm = 0U;

	/*
	 * Ƥγߤޥ
	 */
	at91skyeye_disable_int(~0U);

	/*
	 * Ƥγװ򥯥ꥢ
	 */
	at91skyeye_clear_int(~0U);

#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼ǽν
	 */
	trace_initialize((uintptr) (TRACE_AUTOSTOP));
#endif /* TOPPERS_ENABLE_TRACE */
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
#ifdef TOPPERS_ENABLE_TRACE
	trace_dump(target_fput_log);
#endif /* TOPPERS_ENABLE_TRACE */

#ifndef ENABLE_RETURN_MAIN
	/*
	 *  åȥν
	 */
	target_fput_str("Kernel Exit...");
#else
	target_fput_str("Kernel Shutdown...");
#endif /* ENABLE_RETURN_MAIN */

	/*
	 *  ٤Ƥγߤޥ롥
	 */
	at91skyeye_disable_int(~0U);

	/*
	 *  ARM¸νλ
	 */
	core_terminate();

	/*
	 *  ȯĶ¸νλ
	 */
	at91skyeye_exit();

#ifdef ENABLE_RETURN_MAIN
	kerflg = FALSE;
	nested_lock_os_int_cnt = 0U;
	sus_all_cnt = 0U;
	sus_all_cnt_ctx = 0U;
	sus_os_cnt = 0U;
	sus_os_cnt_ctx = 0U;

	Asm("ldr  r0,  =_ostkpt");
	Asm("ldr  sp,  [r0]");
	Asm("bl   __cs3_start_c");
#endif /* ENABLE_RETURN_MAIN */

#if defined(TOPPERS_ENABLE_GCOV_PART)
	/*
	 *  ξϽλ .gcda եϤʤ褦
	 *  _exit()ƤӽФ
	 */
	extern void _exit(int) NoReturn;
	;
	_exit(0);
#elif defined(TOPPERS_ENABLE_GCOV_FULL)
	exit(0);
#else
	while (1) {
	}
#endif /* TOPPERS_ENABLE_GCOV_PART */
}

/*
 *  ƥ٥ϤΤʸ
 */
void
target_fput_log(char8 c)
{
	usart0_putc(c);
}

/*
 *  ׵饤°
 */
void
x_config_int(InterruptNumberType intno, AttributeType intatr, PriorityType intpri)
{
	ASSERT(VALID_INTNO(intno));

	/*  SC1Ǥϵưϳߵ
	 *  intnoꤵ줿ߤΤߵ
	 */
	idf &= ~INTNO_BITPAT(intno);
	/* ߶ػ */
	at91skyeye_disable_int(~0U);

	/* intnoꤵ줿߳ߤΤߵ */
	at91skyeye_enable_int(~(ipm_mask_tbl[INDEX_IPM(ipm)] | idf));
}

/*
 *  OS߶ػ߾֤ؤΰܹ
 */
void
x_nested_lock_os_int(void)
{
	nested_lock_os_int_cnt++;

	/* ߶ػ */
	at91skyeye_disable_int(~0U);

	/* ޥꤵƤʤߤΤߵ */
	at91skyeye_enable_int(~(os_int_lock_mask | idf));
}

/*
 *  OS߶ػ߾֤β
 */
void
x_nested_unlock_os_int(void)
{
	ASSERT(nested_lock_os_int_cnt > 0);
	nested_lock_os_int_cnt--;

	if (nested_lock_os_int_cnt == 0) {
		/* ߶ػ */
		at91skyeye_disable_int(~0U);

		at91skyeye_enable_int(~(ipm_mask_tbl[INDEX_IPM(ipm)] | idf));
	}
}

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * ̤γߤäν
 */
void
default_int_handler(void)
{
	target_fput_str("Unregistered Interrupt occurs.");
	target_exit();
	ASSERT(0);
}
#endif /* OMIT_DEFAULT_INT_HANDLER */

#ifdef TOPPERS_ENABLE_GCOV_PART
/*
 *  GCOVѥ饤֥
 */

extern void	__gcov_flush();

/*
 *  GCOVؿ
 *   Хå.gcda˽ϤSkyEye*.gcdaե
 */
void
gcov_init(void)
{
	SIL_PRE_LOC;

	SIL_LOC_INT();
	__gcov_flush();
	sil_wrw_mem((uint32 *) 0xFFFE1020, 0);
	SIL_UNL_INT();
}

/*
 *  GCOVǴؿ
 *   Хå.gcda˽ϤSkyEye*.gcdaե*.gcda.bak
 *   ͡ह
 */
void
gcov_pause(void)
{
	SIL_PRE_LOC;

	SIL_LOC_INT();
	__gcov_flush();
	sil_wrw_mem((uint32 *) 0xFFFE1024, 0);
	SIL_UNL_INT();
}

/*
 *  GCOVƳؿ
 *   Хå.gcda˽ϤSkyEye*.gcda.bakե*.gcda
 *   ͡ह
 */
void
gcov_resume(void)
{
	SIL_PRE_LOC;

	SIL_LOC_INT();
	__gcov_flush();
	sil_wrw_mem((uint32 *) 0xFFFE1028, 0);
	SIL_UNL_INT();
}

/*
 *  GCOVϴؿ
 *   Хå.gcda˽Ϥ
 */
void
gcov_dump(void)
{
	SIL_PRE_LOC;

	SIL_LOC_INT();
	__gcov_flush();
	SIL_UNL_INT();
}
#endif /* TOPPERS_ENABLE_GCOV_PART */
