/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2007 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2005-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_serial.c 7368 2013-04-11 11:19:13Z shigihara $
 */

/*
 *		ꥢI/OǥХSIO˥ɥ饤СAT91SKYEYEѡ
 *  USART0
 */

#include "Os.h"
#include "t_syslog.h"
#include "at91skyeye.h"
#include "target_serial.h"

/*
 * ѥХåե
 */
static uint8 usart0_rx_buf;

/*
 * ٥ѥꥢɥ饤н
 */
void
usart0_initialize(void)
{
	/* ǡγǼ襢ɥ쥹 */
	sil_wrw_mem((uint32 *) (USART0_RPR), (uint32) (&usart0_rx_buf));
	sil_wrw_mem((uint32 *) (USART0_RCR), 0x0001);
}

/*
 * ʸå
 */
LOCAL_INLINE boolean
usart0_getready(void)
{
	return(sil_rew_mem((uint32 *) (USART0_RCR)) == 0);
}

/*
 *  ʸμФ
 */
LOCAL_INLINE uint8
usart0_getchar(void)
{
	char8 c;

	c = usart0_rx_buf;
	sil_wrw_mem((uint32 *) (USART0_RPR), (uint32) (&usart0_rx_buf));
	sil_wrw_mem((uint32 *) (USART0_RCR), 0x0001);
	return(c);
}

/*
 *  
 */
void
InitHwSerial(void)
{
}

/*
 *  λ
 */
void
TermHwSerial(void)
{
}

/*
 *  Хåϥɥ
 */
ISR(RxHwSerialInt){
	if (usart0_getready()) {
		RxSerialInt(usart0_getchar());
	}
}
