/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_support.S 7912 2013-09-26 08:50:11Z fsi-dankei $
 */

/*
 *		åװ¸⥸塼 ֥AT91SKYEYEѡ
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* ̵ޥ */
#define CAST(type, val)		(val)	/* 㥹ȤԤޥ */
#include "kernel_impl.h"
#include "offset.h"

/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ
 */
        .text
        .align 2
        .global hardware_init_hook
hardware_init_hook:
        bx  lr

/*
 * ߥϥɥ
 *
 * IRQ 㳰٥ƤӽФ
 */
    .text
    .align 2
    .global irq_handler
irq_handler:
    /* 
     * IRQ⡼ɤǼ¹Ԥ
     */
    /* 
     *  Υ⡼(ѡХ⡼)
     *  ܹԤƥȤ¸
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT) 
    stmfd sp!, {r0-r3, ip, lr, pc} /* pcϥߡ */

    /*
     * spsrϤ뤿IRQ⡼ɤ
     */
    msr   cpsr, #(CPSR_IRQ|CPSR_IRQ_BIT)
    sub   r0, lr, #4
    mrs   r1, spsr

    /*
     *  ߥϥɥ¹ԻΥ⡼ɡʥѡХ⡼ɡˤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT) 
    str   r0, [sp, #0x18] /* Ϥ򥹥å */
    stmfd sp!, {r1}       /* spsr򥹥å¸ */
    mov   lr, sp          /* λΥåΤ */

    /*
     *  ¿ųߤȽ
     */

    ldr   r2, =excpt_nest_count /* 㳰ߥͥȲ */
    ldr   r3, [r2]
    add   r0, r3, #1            /* 㳰ߥͥȲ򹹿 */
    str   r0, [r2]
    cmp   r3, #0    
    bne   irq_handler_1

    /* 
     * ܤ㳰ʳߡˤʤ饹åѹ
     */
    ldr   r0, =_ostkpt
    ldr   sp, [r0]

irq_handler_1:

    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    ldr   r3, =AIC_IVR
    ldr   r1, [r3]

    /*
     *  װȽ
     */
    ldr   r3, =AIC_ISR
    ldr   r1, [r3]

    /*
     *  װߴźؤѴ
     *  װֹϢ³Ƥ118
     */
    sub   r3, r1, #TMIN_INTNO


	/*
	 *  åΥХեå
	 */
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  C1ISRξ硤å˥󥰤¹Ԥʤ
	 */
    ldr   r0, =isr_callevel_tbl
    ldr   r0, [r0, r3, lsl #1] /* ¹ԤISRcallevel */
    ldr   r1, =TSYS_ISR1
    and   r0, r0, r1
    cmp   r0, #0
    bne   stack_monitoring_exit

	/*
	 *  ¿ųߤξϥåΥå˥󥰤Ԥʤ
	 */
    ldr   r0, =excpt_nest_count /* 㳰ߥͥȲ */
    ldr   r1, [r0]
    cmp   r1, #1
    bne   int_nested

	/*
	 *  åݥ󥿥å
	 */
    ldr   r0, =p_runtsk					/* p_runtskɤ߹ */
    ldr   r1, [r0]
    ldr   r2, [r1, #TCB_p_tinib]		/* ֥åƬɥ쥹 */
    ldr   r2, [r2, #TINIB_stk]			/* åƬɥ쥹 */
    cmp   lr, r2						/* åݥ(lr) <= åƬξ硤 */
    ble   stack_monitoring_error_isr	/* åСեȯ */

	/*
	 *  ޥåʥСå
	 */
    ldr   r1, [r2]						/* åƬɥ쥹ޥåʥСΰͼ */
    ldr   r0, =STACK_MAGIC_NUMBER
    cmp   r1, r0						/* ޥåʥС˲Ƥʤ硤 */
    beq   stack_monitoring_exit			/* ߽ */
    b     stack_monitoring_error_isr	/* ޥåʥС˲Ƥ硤åСեȯ */

	/*
	 *  ¿ųߤξ
	 */
int_nested:
	/*
	 *  ߥåΥХեå
	 */
	/*
	 *  ḁ̊å
	 */
    ldr   r1,   =isr_p_isrcb_tbl
    ldr   r1,   [r1, r3, lsl #2] 				/* ¹ԤISRδ֥å */
	ldr   r2,	[r1, #ISRCB_p_intinib]			/* ֹбISRCBΥɥ쥹 */
	ldr   r2,   [r2, #INTINIB_remain_stksz]		/* ֹбåνɥ쥹 */
	ldr   r1,   =_ostk							/* ߥåƬɥ쥹ǼƤݥ */
	ldr   r0,   [r1]							/* ߥåƬɥ쥹 */
	add   r2,   r2,	 r0							/* Ƭɥ쥹ISRλѤ륹å */
	cmp   sp,   r2								/* SP <= Ƭɥ쥹ISRλѤ륹å ξNG  */
	ble   stack_monitoring_error_isr			/* å̤­Ƥ硤åСե */

	/*
	 *  ޥåʥСå
	 */
    ldr   r2, [r0]						/* åƬɥ쥹ޥåʥСΰͼ */
    ldr   r0, =STACK_MAGIC_NUMBER
    cmp   r2, r0						/* ޥåʥС˲Ƥ硤 */
    bne   stack_monitoring_error_isr	/* åСեȯ */
stack_monitoring_exit:
#endif /* CFG_USE_STACKMONITORING */


    /*
     *  callevel ¸
     */
    ldr   r0, =callevel_stat
    ldrh  r2, [r0]
    stmfd sp!, {r2} 

    /*
     *  callevel 
     */
    ldr   r1, =isr_callevel_tbl
    ldr   r1, [r1, r3, lsl #1] /* ¹ԤISRcallevel */
	orr   r1, r1, r2
    strh   r1, [r0]

    /*
     *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
     *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
     *  ¸
     */
    ldr   r0, =isr_ipm_tbl      /* ͥ٤ */
    ldr   r1, [r0, r3, lsl #2]  /* r1<-ͥ   */
    ldr   r0, =ipm              /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r2, [r0]              
    stmfd sp!,{r2}         
    str   r1, [r0]              /* (ǥ)ͥ٥ޥ򥻥å */

    /*
     * (ǥ)ͥ٥ޥ
     * 
     * դߤγͥ٤ꤵ줿׵ػߥե饰
     * ơ֥ͤ(ǥ)Ƴߤγ׵ػߥե饰ξ֤
     * ݻѿͤȤORIRCγ׵ػߥե饰˥åȤ
     */
    rsb   r1, r1,  #0           /* ǥåȤʤ褦ȿž */
    ldr   r0, =ipm_mask_tbl     /* (ǥ)γͥ٤¸뤿 */
    ldr   r2, [r0, r1, lsl #2]  /* ׵ػߥե饰 */
    ldr   r0, =idf              /* Ƴߤγ׵ػߥե饰ξ֤ */
    ldr   r1, [r0]
    /*
     * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
     * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
     * IRCγߵĥ쥸ؤͤꤹ
     */
    mvn   lr, #0
    ldr   r0, =AIC_IDCR
    str   lr, [r0]
    orr   r1, r1, r2            /* ޥꤵƤʤߤε */
    mvn   r1, r1                /* ͤ */
    ldr   r0, =AIC_IECR
    str   r1, [r0]

    /*
     *  p_runisr ¸
     */
    ldr   r0, =p_runisr
    ldr   r1, [r0]
    stmfd sp!, {r1}

    /*
     *  p_runisr 
     */
    ldr   r1, =isr_p_isrcb_tbl
    ldr   r1, [r1, r3, lsl #2] /* ¹ԤISRδ֥å */
    str   r1, [r0]

    /*
     *  ߥϥɥεưϤ
     */
    ldr   r0, =isr_tbl         /* ߥϥɥơ֥ɤ߽Ф  */
    ldr   r0, [r0, r3, lsl #2] /* r0<-ߥϥɥ            */


    /*
     *  ߴźװؤѴ
     */
    add   r3, r3, #TMIN_INTNO

    /*
     *  EOIΤ¸
     */
    mov   r1, #1
    mov   r1, r1, lsl r3
    stmfd sp!, {r1}

    /* 
     * ߵ
     */
    msr   cpsr, #(CPSR_SVC)

    /* 
     * ߥϥɥθƤӽФ
     */
    mov   lr, pc
    bx    r0

	/*
	 *  ߥåΥХեå
	 *  ߤäåݥ󥿤äϤʤΤǡ
	 *  ޥåʥСåΤ߼»
	 */
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  ޥåʥСå
	 */
    ldr   r1, =_ostk					/* ߥåƬɥ쥹 */
    ldr   r2, [r1]
    ldr   r1, [r2]						/* åƬɥ쥹ޥåʥСΰͼ */
    ldr   r2, =STACK_MAGIC_NUMBER
    cmp   r1, r2						/* ޥåʥС˲Ƥ硤 */
    bne   stack_monitoring_error_isr	/* åСեȯ */
#endif /* CFG_USE_STACKMONITORING */

    ldr   r1, =p_runisr
	ldrh  r2, [r1]
	cmp   r2, #0
	beq   skip_exit_isr2

    /*
     * C2ISRλå
     */
	bl    exit_isr2

skip_exit_isr2:

    /*
     * ͥγߤػߤ
     */
	bl    x_lock_all_int

    /*
     * ߥꥢ
     */
    ldmfd sp!,{r0}
    ldr   r3, =AIC_EOI
    str   r0, [r3]

    /*
     *  p_runisr 
     */
    ldr   r1, =p_runisr
    ldmfd sp!,{r2}
    str   r2, [r1]
        
target_ret_int:
    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!, {r1}             /* γͥ٥ޥ */
    ldr   r0, =ipm              /* ͥ٥ޥ     */
    str   r1, [r0]
    rsb   r1, r1,  #0           /* ǥåȤʤ褦ȿž */
    ldr   r0, =ipm_mask_tbl     /* (ǥ)γͥ٤Τ¸뤿 */
    ldr   r2, [r0, r1, lsl #2]  /* ׵ػߥե饰 */    
    ldr   r0, =idf              /* Ƴߤγ׵ػߥե饰ξ֤ */
    ldr   r1, [r0]

	/*
	 * OS߶ػ߾֤ǳߤä(C1ISR)
	 * os_int_lock_maskγߤػߤɬפ
	 */
	ldr   r0, =nested_lock_os_int_cnt
	ldr   r3, [r0]
	cmp   r3, #0
	beq   target_ret_int_1

	ldr   r0, =os_int_lock_mask
	ldr   r3, [r0]
	orr   r1, r1, r3

target_ret_int_1:
    /*
     * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
     * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
     * IRCγߵĥ쥸ؤͤꤹ
     */
    mvn   lr, #0
    ldr   r0, =AIC_IDCR
    str   lr, [r0]
    orr   r1, r1, r2            /* ޥꤵƤʤߤε */
    mvn   r1, r1                /* ͤ */
    ldr   r0, =AIC_IECR
    str   r1, [r0]

    /*
     *  callevel 
	 *  r3ret_intǻȤ
     */
    ldr   r1, =callevel_stat
	ldrh  r3, [r1]
    ldmfd sp!,{r2}
    strh   r2, [r1]

    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2
    
    /*
     * νARM¸Ǽ¹
     */
    b     ret_int

/*
 *
 * åȰ¸㳰
 *
 */
    .text
    .global target_exc_handler
target_exc_handler:
    /*
     *  㳰¹ԤΥ⡼ɡʥѡХ⡼ɡˤ
     *  ߶ػ߾֡OS߶ػ߾֤CPU㳰ȯ
     *  ֤Ѿ
     *  λΥ쥸Ƥϰʲ̤
     *    r0 : lr()
     *    r1 : spsr
     *    r2 : 㳰ֹ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT)
    str   r0, [sp, #0x18] /* Ϥ򥹥å */
    stmfd sp!, {r1}       /* spsr򥹥å¸ */
    mov   lr, sp          /* λΥåΤ */

    ldr   r0, =ipm        /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r3, [r0]
    stmfd sp!, {r3}

    /* 
     * ƥȽΤᡤexcpt_nest_count 򥹥å¸
     * å¸ߤexcpt_nest_count-1ȼǤ뤬
     * åѤǤǥХåԤ䤹Τǡå
     * ¸
     */
    ldr   r0, =excpt_nest_count
    ldr   r3, [r0]
    stmfd sp!, {r3}

    mov   r3,  sp         /* 㳰ե졼Ϥ¸ */

    /*
     * ͥCPU㳰Ƚꤹ
     * 
     * ͥCPU㳰ϡͥ¹桤߶ػ߾֡
     * OS߶ػ߾֡ͥγߥϥɥ¹ȯ
     * CPU㳰Ǥ롥ARMξϡSPSRI/Fե饰Τ줫'1'ʤ顤
     * 
     */
    tst   r1, #(CPSR_FIQ_BIT|CPSR_IRQ_BIT) 
    bne   target_kernel_unc_exc_handler /* ͥCPU㳰ν */

    /*
     * ȯΥƥȤȽ
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    add   r1, r1, #1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_exc_handler_1

    /* 
     * ƥȤCPU㳰ȯ
     * å󥿥ƥȤڤؤ
     */
    ldr  r0, =_ostkpt
    ldr  sp, [r0]

target_exc_handler_1:
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /* 
     * ȯγͥ٥ޥ򥹥å¸ 
     * ߥϥɥȽи롼ͭ뤿¸
     */
    ldr   r0, =ipm
    ldr   r1, [r0]
    stmfd sp!, {r1}

    /* 
     * ץƥեåOS߶ػ߾֤Ǽ¹Ԥ
     */
	bl    x_nested_lock_os_int
	bl    x_unlock_all_int

	/*
	 *  ͥ뵯ưƤʤ˵CPU㳰ϡ̵¥롼פ
	 */
	ldr   r0, =kerflg  /* kerflgFALSEʤ̵¥롼 */
	cmp   r0, #0
	beq   infinity_loop

    /*
     * CPU㳰ȯ硤OSE_OS_PROTECTION_EXCEPTIONѥ᡼Ȥ
     * ץƥեåƤӽФ
     */
    mov   r0, #E_OS_PROTECTION_EXCEPTION 	/* call_protectionhk_mainΰ */
    bl    call_protectionhk_main		/* ץƥեåθƤӽФ */


    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!, {r1}             /* γͥ٥ޥ */
    ldr   r0, =ipm              /* ͥ٥ޥ     */
    str   r1, [r0]

    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2

	/*
	 * ץƥեåDisableAllInterrupts줿ˡspsrȿǤ
	 */
	mrs   r0, cpsr
	and   r0, r0,#(CPSR_IRQ_BIT)
    ldr   r1, [sp]
	orr   r1, r1, r0
	str   r1, [sp]


	/*
	 * ץƥեå¹ԸOS߶ػߤ߶ػߤˤ
	 */
	stmfd sp!, {r3}
	bl    x_lock_all_int
	bl    x_nested_unlock_os_int
	ldmfd sp!, {r3}

    /*
     * νARM¸Ǽ¹
     *  r3ret_intǻȤ
     */
    ldr   r0, =callevel_stat
	ldrh  r3, [r0]
    b     ret_int


/*
 *
 * ͥCPU㳰ν
 *
 */
target_kernel_unc_exc_handler:
    /*
     * ȯΥƥȤȽ
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    add   r1, r1, #1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_kernel_unc_exc_handler_1
    
    /* 
     * ƥȤCPU㳰ȯ
     * å󥿥ƥȤڤؤ
     */
    ldr   r0, =_ostkpt
    ldr   sp, [r0]

target_kernel_unc_exc_handler_1:
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */
    
   /*
    * ƥ֡ʥƥȤϽˤCPU㳰ȯξ֤
    */
    ldr   r0, [lr]             /* CPU㳰ȯCPSRμ */
    and   r0, r0, #(CPSR_IRQ_BIT|CPSR_FIQ_BIT)
    orr   r0, r0, #(CPSR_SVC)
    msr   cpsr, r0

    /* 
     * ץƥեåOS߶ػ߾֤Ǽ¹Ԥ
     */
	bl    x_nested_lock_os_int

	/*
	 *  ͥ뵯ưƤʤ˵CPU㳰ϡ̵¥롼פ
	 */
	ldr   r0, =kerflg  /* kerflgFALSEʤ̵¥롼 */
	ldr   r1, [r0]
	cmp   r1, #0
	beq   infinity_loop

    /*
     * CPU㳰ȯ硤OSE_OS_PROTECTION_EXCEPTIONѥ᡼Ȥ
     * ץƥեåƤӽФ
     */
    mov   r0, #E_OS_PROTECTION_EXCEPTION 	/* call_protectionhk_mainΰ */
    bl    call_protectionhk_main			/* ץƥեåθƤӽФ */

	bl    x_nested_unlock_os_int

    /*
     *  㳰ߤΥͥȥȡexcpt_nest_count)Υǥ
     */
    ldr   r0, =excpt_nest_count   /* r0 <-excpt_nest_count */
    ldr   r1, [r0]
    sub   r2, r1, #1
    str   r2, [r0]

    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2

    /*
     * CPU㳰
     */
    ldmfd sp!,{r1}              /* CPSR */
    msr   spsr, r1              /* cpsrspsr */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /* ƥȤ^դʤΤǡcpsr <- spsr */


/*
 *  ̵¥롼׽
 */
infinity_loop:
	b infinity_loop
