/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: fl850fl4.h 7865 2013-09-17 14:30:01Z honda $
 */
/*
 *		FL-850/FL4ܡɤ
 */

#ifndef TOPPERS_FL850FL4_H
#define TOPPERS_FL850FL4_H

#include "v850e2_gcc/v850e2_fx4.h"

/*
 *  å®
 */
#define PCLOCK			(32000000)

/*
 *  PLLϢ
 */
#define MAINOSC_CLOCK	4   /* MainOSC is 4MHz */
#define PLL0_CLOCK		64  /* PLL0 is 64MHz */
#define PLL1_CLOCK		32  /* PLL1 is 32MHz */
#define PLL2_CLOCK		80  /* PLL2 is 80MHz */


/* Port 24 Configuration
     P24_8: LED1(OUT)
     P24_9: LED2(OUT)
     P24_10: LED3(OUT)
     P24_11: LED4(OUT)
 */
#define P24_MASK						((uint16) 0x0F00)
#define PMC24_INIT						((uint16) 0x0000)
#define PFCE24_INIT						((uint16) 0x0000)
#define PFC24_INIT						((uint16) 0x0000)
#define PM24_INIT						((uint16) 0xF0FF)
#define P24_INIT						((uint16) 0x0F00)

/* Port 3 Configration
     P3_7 : URTET3(OUT)
     P3_8 : URTER3(IN)
     P3_10 : URTET5(OUT)
     P3_9  : URTER5(IN)
 */
#define UARTE3_P3_MASK					((uint16) 0x0180)
#define UARTE3_PMC3_INIT				((uint16) 0x0180)
#define UARTE3_PFC3_INIT				((uint16) 0x0180)
#define UARTE3_PFCE3_INIT				((uint16) 0x0180)
#define UARTE3_PM3_INIT					((uint16) 0x0100)

#define UARTE5_P3_MASK					((uint16) 0x0600)
#define UARTE5_PMC3_INIT				((uint16) 0x0600)
#define UARTE5_PFC3_INIT				((uint16) 0x0000)
#define UARTE5_PFCE3_INIT				((uint16) 0x0600)
#define UARTE5_PM3_INIT					((uint16) 0x0200)

/* V850Drv_led_output() */
#define POS_LED1						((uint16) 0x01)
#define POS_LED2						((uint16) 0x02)
#define POS_LED3						((uint16) 0x04)
#define POS_LED4						((uint16) 0x08)
#define POS_LED_ALL						((uint16) 0x0F)

#define MASK_LED_ALLON					((uint16) 0x0F00)
#define MASK_LED_ALLOFF					((uint16) 0x0000)
#define MASK_LED1TO4					((uint16) 0x000F)
#define P24_LED_GAP						((uint8) 8)

#endif /* TOPPERS_FL850FL4_H */
