/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ  
 *
 *  $Id: start.S 7945 2013-10-04 10:51:00Z honda $  
 */

/*
 *		ͥбΥȥåץ⥸塼V850ѡ
 */

#define OMIT_INCLUDE_OS_CFG		/* Os_Cfg.h󥯥롼޻ */
#define TOPPERS_MACRO_ONLY
#define UINT_C(val)			(val)		/* ʤޥ */

#include "v850asm.inc"
#include "kernel_impl.h"

	.section .text
	.align  4
	.global _reset
FLABEL(_reset)
	di

/*
 *  Initialize CPU register to avoid Compare Unit Mismatch Error
 */
	mov	r0,r1			// Assembler Reserved Resistor
	mov	r0,r2			// hp:Handler Pointer
	mov	r0,r3			// sp:Stack Pointer
	mov	r0,r4			// gp:Global Pointer
	mov	r0,r5			// tp:Text Pointer
	mov	r0,r6			// Argument Registor
	mov	r0,r7			// Argument Registor
	mov	r0,r8			// Argument Registor
	mov	r0,r9			// Argument Registor
	mov	r0,r10			// Work Resistor
	mov	r0,r11			// Work Resistor
	mov	r0,r12			// Work Resistor
	mov	r0,r13			// Work Resistor
	mov	r0,r14			// Work Resistor
	mov	r0,r15			// Work Resistor
	mov	r0,r16			// Work Resistor
	mov	r0,r17			// Work Resistor
	mov	r0,r18			// Work Resistor
	mov	r0,r19			// Work Resistor
	mov	r0,r20			// Variable Resistor
	mov	r0,r21			// Variable Resistor
	mov	r0,r22			// Variable Resistor
	mov	r0,r23			// Variable Resistor
	mov	r0,r24			// Variable Resistor
	mov	r0,r25			// Variable Resistor
	mov	r0,r26			// Variable Resistor
	mov	r0,r27			// Variable Resistor
	mov	r0,r28			// Variable Resistor
	mov	r0,r29			// Variable Resistor
	mov	r0,r30			// ep:Element Pointer
	mov	r0,r31			// lp:Link Pointer

	ldsr	r0,31			// BSEL : main bank, CPU function grp
	ldsr	r0,0			// EIPC
	ldsr	r0,2			// FEPC

	ldsr	r0,11			// SCCFG
	ldsr	r0,12			// SCBP
	
	ldsr	r0,16			// CTPC
	ldsr	r0,18			// DBPC
	ldsr	r0,20			// CTBP
	
	ldsr	r0,28			// EIWR
	ldsr	r0,29			// FEWR
	ldsr	r0,30			// DBWR

	Lea		VPNECR,r6		// VPNECR
	st.w	r0,0[r6]
	Lea		VPNADR,r6		// VPNADR
	st.w	r0,0[r6]
	Lea		VPNTID,r6		// VPNTID
	st.w	r0,0[r6]
	Lea		VPTECR,r6		// VPTECR
	st.w	r0,0[r6]
	Lea		VPTADR,r6		// VPTADR
	st.w	r0,0[r6]
	Lea		VPTTID,r6		// VPTTID
	st.w	r0,0[r6]

	Lea		0x1000,r6
	ldsr	r6,31			// BSEL : Processor Garde Violation bank, Processor Garde grp
	ldsr	r0,1			// VSTID
	ldsr	r0,2			// VSADR
	ldsr	r0,24			// MCA
	ldsr	r0,25			// MCS

	Lea		0x1010,r6
	ldsr	r6,31			// BSEL : Soft Paging bank, Processor Garde grp
	ldsr	r0,4			// VMTID
	ldsr	r0,5			// VMADR

	ldsr	r0,31			// BSEL : main bank, CPU function grp

	/*
	 * Ƽݥ󥿤ν(SP/TP/EP/GP/CTBP)
	 */
	Lea     __ostkpt, r3
	ld.w	0[r3],r3
	Lea		__tp, tp
	Lea		__ep , ep
	Lea 	__gp , gp
	Lea		__ctbp , r6
	ldsr	r6 , 20
	
	/*
	 *  hardware_init_hook θƽФ0 Ǥʤ
	 *
	 *  åȥϡɥ˰¸ɬפʽ
	 *  ϡhardware_init_hook ȤؿѰդ롥
	 */
	Lea		hardware_init_hook, r1
	cmp		r0, r1
	be		hardware_init_hook_end
	jarl	hardware_init_hook, lp
FLABEL(hardware_init_hook_end)
	
	/*
	 *  bssΥꥢ
	 *   饤󤵤ƤΤ4ĹԤ
	 */
	Lea		__bss_start, ep
	Lea		__bss_end, r6
FLABEL(bss_clear_start)
	cmp		ep, r6
	be		bss_clear_end
	sst.w	r0, 0[ep]
	add		4, ep
	br		bss_clear_start
FLABEL(bss_clear_end)

#ifndef OMIT_DATA_INIT
	/*
	 *  dataνROMб
	 *
	 *  __idata_start  __idata_end ޤǤ__data_start ʹߤ
	 *  ԡ롥
	 */
	Lea		__idata_start, r6
	Lea		__idata_end,   r7
	Lea		__data_start,  r8
FLABEL(data_init_start)
	cmp		r6, r7
	be		data_init_end
	ld.w	0[r6], r9
	st.w	r9, 0[r8]
	add		4, r6
	add		4, r8
	br		data_init_start
FLABEL(data_init_end)
#endif /* OMIT_DATA_INIT */

	/*
	 *  software_init_hook ƽФ0 Ǥʤ
	 *
	 *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
	 *  ϡsoftware_init_hook ȤؿѰդ
	 *  褤
	 */

	Lea		software_init_hook, r1
	cmp		r0, r1
	be		software_init_hook_end
	jarl	software_init_hook, r31
FLABEL(software_init_hook_end)

	/*
	 *  ͥư롥
	 */
	jarl    _target_hardware_initialize, r31
	jarl    _main, r31
	halt

	.end
