/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: rczbasev850.h 7959 2013-10-10 05:06:00Z fsi-dankei $
 */
/*
 *		RC-Z-BASE-V850ܡɤ
 */

#ifndef TOPPERS_RCZBASEV850_H
#define TOPPERS_RCZBASEV850_H

#if !(defined(__f3550__))
#error Target MCU type is not supported!!
#endif

#ifdef __f3550__

/*
 *  uPD70F3550 V8502E/FG4
 */

#define V850FG4

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME	"RCZBASEV850(V850E2/FG4:uPD70F3550)"

/*
 *  PLLϢ
 */
#define MAINOSC_CLOCK	10  /* MainOSC is 10MHz */
#define PLL0_CLOCK		80  /* PLL0 is 80MHz */
#define PLL1_CLOCK		50  /* PLL1 is 50MHz */

/*
 * ѤUARTEΥݡֹ
 */
#define TARGET_UARTE_PORT	10
//#define TARGET_UARTE_PORT 3

/*
 *  UARTE10(ĥüҲ)³Ƥݡ
 */
#define UARTE10_PORT_NO	0

/*
 *  P0_8 : URTET10TX
 *  P0_9 : URTER10RX
 */
#define UARTE10_P_MASK				((uint16) 0x0300)
#define UARTE10_PMC_INIT			((uint16) 0x0300)
#define UARTE10_PFC_INIT			((uint16) 0x0000)
#define UARTE10_PFCE_INIT			((uint16) 0x0000)
#define UARTE10_PM_INIT				((uint16) 0x0200)


/*
 *  UARTE3³Ƥݡ
 */
#define UARTE3_PORT_NO	1

/*
 *  P1_10 : URTET3TX
 *  P1_11 : URTER3RX
 */
#define UARTE3_P_MASK				((uint16) 0x0C00)
#define UARTE3_PMC_INIT				((uint16) 0x0C00)
#define UARTE3_PFC_INIT				((uint16) 0x0C00)
#define UARTE3_PFCE_INIT			((uint16) 0x0000)
#define UARTE3_PM_INIT				((uint16) 0x0800)


/*
 *  P0_0 : LED1(OUT)
 */

/*
 * LED³Ƥݡ
 */
#define LED_PORT_NO	0

#define LED_PORT_MASK				((uint16) 0x0001)
#define LED_PORT_PMC_INIT			((uint16) 0x0000)
#define LED_PORT_PFCE_INIT			((uint16) 0x0000)
#define LED_PORT_PFC_INIT			((uint16) 0x0000)
#define LED_PORT_PM_INIT			((uint16) 0x0000)
#define LED_PORT_P_INIT				((uint16) 0x0000)

#define LED_BIT						((uint16) 0x0001)

#endif /* __f3550__ */

#define USE_OSTM

#include "v850e2_gcc/v850e2_fx4.h"

#endif /* TOPPERS_RCZBASEV850_H */
